MODULE	HORNER_SCHEME_MODULE
#include "include/Utilities/CONCAT_MACRO.F90"
!    USE MULT_OR_ZERO_MODULE
#define MULT_OR_ZERO(x,y) x*y
#ifdef __PGI
#define NO_QP
#endif
    IMPLICIT NONE
    PRIVATE
    INTEGER,PARAMETER::SP=SELECTED_REAL_KIND(5)
    INTEGER,PARAMETER::DP=SELECTED_REAL_KIND(15)
    INTEGER,PARAMETER::QP=SELECTED_REAL_KIND(30)

    INTERFACE COMPUTE_POLYNOMIAL
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_DP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_DP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_DP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_DP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_DP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_DP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_DP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP7
#ifndef NO_QP
        !==================================== 		Quadruple precision ===================== !
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_QP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_QP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_QP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_QP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_QP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_QP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_QP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP7
#endif
        ! ========================  Single precision ============================== !
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_SP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP1
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_SP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP2
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_SP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP3
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_SP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP4
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_SP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP5
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_SP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP6
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_REAL_SP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP7
        MODULE PROCEDURE COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP7
    ENDINTERFACE
    PUBLIC :: COMPUTE_POLYNOMIAL
CONTAINS
#define _FUNCNAME COMPUTE_POLYNOMIAL_REAL_REAL_DP
#define _ARR_TYPE REAL
#define _ARG_TYPE REAL
#define _RES_TYPE REAL
#define _KIND DP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_REAL_COMPLEX_DP
#define _ARR_TYPE REAL
#define _ARG_TYPE COMPLEX
#define _RES_TYPE COMPLEX
#define _KIND DP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_COMPLEX_REAL_DP
#define _ARR_TYPE COMPLEX
#define _ARG_TYPE REAL
#define _RES_TYPE COMPLEX
#define _KIND DP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_DP
#define _ARR_TYPE COMPLEX
#define _ARG_TYPE COMPLEX
#define _RES_TYPE COMPLEX
#define _KIND DP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#ifndef NO_QP

#define _FUNCNAME COMPUTE_POLYNOMIAL_REAL_REAL_QP
#define _ARR_TYPE REAL
#define _ARG_TYPE REAL
#define _RES_TYPE REAL
#define _KIND QP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_REAL_COMPLEX_QP
#define _ARR_TYPE REAL
#define _ARG_TYPE COMPLEX
#define _RES_TYPE COMPLEX
#define _KIND QP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_COMPLEX_REAL_QP
#define _ARR_TYPE COMPLEX
#define _ARG_TYPE REAL
#define _RES_TYPE COMPLEX
#define _KIND QP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_QP
#define _ARR_TYPE COMPLEX
#define _ARG_TYPE COMPLEX
#define _RES_TYPE COMPLEX
#define _KIND QP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME
#endif

#define _FUNCNAME COMPUTE_POLYNOMIAL_REAL_REAL_SP
#define _ARR_TYPE REAL
#define _ARG_TYPE REAL
#define _RES_TYPE REAL
#define _KIND SP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_REAL_COMPLEX_SP
#define _ARR_TYPE REAL
#define _ARG_TYPE COMPLEX
#define _RES_TYPE COMPLEX
#define _KIND SP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_COMPLEX_REAL_SP
#define _ARR_TYPE COMPLEX
#define _ARG_TYPE REAL
#define _RES_TYPE COMPLEX
#define _KIND SP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME

#define _FUNCNAME COMPUTE_POLYNOMIAL_COMPLEX_COMPLEX_SP
#define _ARR_TYPE COMPLEX
#define _ARG_TYPE COMPLEX
#define _RES_TYPE COMPLEX
#define _KIND SP
#include "include/Utilities/horner_scheme_template.F90"
#undef _ARR_TYPE
#undef _ARG_TYPE
#undef _RES_TYPE
#undef _KIND
#undef _FUNCNAME
ENDMODULE
